
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public class Main
{

    public Main() throws IOException
    {

    }

    private void solve() throws IOException
    {
        int n = nextInt(), x = nextInt();
        BigInteger a[] = new BigInteger[n];
        int sz = 0;
        for (int i = 0; i < n; i++)
        {
            a[i] = parse(next());
        }
        BigInteger l = parse(next());
        BigInteger r = parse(next());
        sort(a);
        BigInteger b[] = new BigInteger[n];
        for (int i = 0; i < n; i++)
        {
            if (l.compareTo(a[i]) <= 0 && a[i].compareTo(r) <= 0)
            {
                b[sz++] = a[i];
            }
        }
        if ((sz == 0 || b[0].compareTo(l.add(BigInteger.ONE)) > 0) || b[sz - 1].compareTo(r.subtract(BigInteger.ONE)) < 0)
        {
            out.println(r.subtract(l).subtract(BigInteger.ONE).subtract(BigInteger.valueOf(sz)));
        }
        else
        {
            for (int i = 1; i < sz; i++)
            {
                if (b[i].subtract(b[i - 1]).compareTo(BigInteger.valueOf(3)) >= 0)
                {
                    out.println(r.subtract(l).subtract(BigInteger.ONE).subtract(BigInteger.valueOf(sz)));
                    return;
                }
            }
            out.println(-1);
        }
    }

    BigInteger parse(String s)
    {
        BigInteger cur = BigInteger.ZERO;
        int val = 0;
        for (int j = 0; j < s.length(); j++)
        {
            if (s.charAt(j) == '.')
            {
                cur = cur.multiply(BigInteger.valueOf(256)).add(BigInteger.valueOf(val));
                val = 0;
            }
            else
            {
                val = val * 10 + (s.charAt(j) - '0');
            }
        }
        cur = cur.multiply(BigInteger.valueOf(256)).add(BigInteger.valueOf(val));
        return cur;
    }

    void sort(int a[])
    {
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            int t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        Arrays.sort(a);
    }

    void sort(BigInteger a[])
    {
        /*
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            BigInteger t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        */
        Arrays.sort(a);
    }

    public static void main(String[] args) throws IOException
    {
        new Main().run();
    }

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);
    String next() throws IOException
    {
        while (st == null || !st.hasMoreTokens())
        {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException
    {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException
    {
        return Long.parseLong(next());
    }

    private void run() throws IOException
    {
        solve();
        out.close();
    }

}